//=============================================================================
//	Little Smalltalk, version 3
//	Written by Tim Budd, Oregon State University, July 1988
//
//	Symantec Think Class Library interface code Julian Barkway, April 1994 
//
//	CSelectPane.h
//	-------------
//	Declarations for a text editing pane which only allows selections.
//
//=============================================================================

#define _H_CSelectPane

#include "CTextPane.h"

struct CSelectPane : CTextPane {
	void	ISelectPane (CView *encl, CBureaucrat *super, 
						SizingOption hSizing, SizingOption vSizing, short lineLength);

	void	Deactivate (void);
	void	DoClick (Point hitPt, short modifierKeys, long when);
};
