//=============================================================================
//	Little Smalltalk, version 3
//	Written by Tim Budd, Oregon State University, July 1988
//
//	Symantec Think Class Library interface code 
//		Julian Barkway, April 1994, all rights reserved. 
//
//	CLStSwitchboard.cp
//	------------------
//	Overridden merthods from CSwitchboard
//=============================================================================

#include "CLStSwitchboard.h"
#include "CLStApp.h"

extern CLStApp		*gSmalltalk;
extern CApplication	*gApplication;

//={OVERRIDE}======================================================================
// GetAnEvent - get the next event and store it in gApplication for later retrieval
//=================================================================================
Boolean	CLStSwitchboard::GetAnEvent (EventRecord *event)
{
	Boolean 	retVal;
	WindowPtr 	w;
	
	retVal = inherited::GetAnEvent (event);
	((CLStApp *)gApplication)->lastEvent = *event;
	if  (event->what == mouseDown) {
		((CLStApp *)gApplication)->winPart = FindWindow (event->where, &w);
		if (((CLStApp *)gApplication)->winPart == inMenuBar) {
			gSmalltalk->smalltalkCmd   = FALSE;
			gSmalltalk->lastEvent.what = 0;
		}
	}
	else
		((CLStApp *)gApplication)->winPart = 0;
		
	return retVal;
}
